// Code generated by go-swagger; DO NOT EDIT.

package app_setup

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"

	models "gitlab.com/pear-slices/mobile_platform/bitrise-step-api-build-trigger/models"
)

// NewAppCreateParams creates a new AppCreateParams object
// with the default values initialized.
func NewAppCreateParams() *AppCreateParams {
	var ()
	return &AppCreateParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewAppCreateParamsWithTimeout creates a new AppCreateParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewAppCreateParamsWithTimeout(timeout time.Duration) *AppCreateParams {
	var ()
	return &AppCreateParams{

		timeout: timeout,
	}
}

// NewAppCreateParamsWithContext creates a new AppCreateParams object
// with the default values initialized, and the ability to set a context for a request
func NewAppCreateParamsWithContext(ctx context.Context) *AppCreateParams {
	var ()
	return &AppCreateParams{

		Context: ctx,
	}
}

// NewAppCreateParamsWithHTTPClient creates a new AppCreateParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewAppCreateParamsWithHTTPClient(client *http.Client) *AppCreateParams {
	var ()
	return &AppCreateParams{
		HTTPClient: client,
	}
}

/*AppCreateParams contains all the parameters to send to the API endpoint
for the app create operation typically these are written to a http.Request
*/
type AppCreateParams struct {

	/*App
	  App parameters

	*/
	App *models.V0AppUploadParams

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the app create params
func (o *AppCreateParams) WithTimeout(timeout time.Duration) *AppCreateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the app create params
func (o *AppCreateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the app create params
func (o *AppCreateParams) WithContext(ctx context.Context) *AppCreateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the app create params
func (o *AppCreateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the app create params
func (o *AppCreateParams) WithHTTPClient(client *http.Client) *AppCreateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the app create params
func (o *AppCreateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithApp adds the app to the app create params
func (o *AppCreateParams) WithApp(app *models.V0AppUploadParams) *AppCreateParams {
	o.SetApp(app)
	return o
}

// SetApp adds the app to the app create params
func (o *AppCreateParams) SetApp(app *models.V0AppUploadParams) {
	o.App = app
}

// WriteToRequest writes these params to a swagger request
func (o *AppCreateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.App != nil {
		if err := r.SetBodyParam(o.App); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
